#######################################################
# Trapped Factors and China's Impact on Global Growth
# Bloom, Romer, Terry, Van Reenen
# Code to replicate Figure 1
# Questions to stephenjamesterry@gmail.com
######################################################

rm(list=ls())
Data = read.csv(file="Figure_1_Data.csv",header=TRUE,sep=",")

fsize <- 10
lwidnum <- 2.5
  
pdf(file = "Figure_1.pdf")
par(ps = fsize, cex = 1, cex.main = 1.5, cex.lab=1.5, cex.axis=1.25)
plot(Data$year, 100*Data$ratio.RoW, col=1, type="l",
   ylim=c(0, 10), lwd=lwidnum, main='Low-Cost Imports in the OECD', ylab="Percent of Total OECD GDP",
   lty=1, pch=1, xlab="Year")
points(Data$year, 100*Data$ratio.RoW, col=1, pch=1)
lines(Data$year, 100*Data$ratio.CHA, col=4, lwd=lwidnum, lty=1, pch=2)
points(Data$year, 100*Data$ratio.CHA, col=4, pch=2)
legend("topleft", c("Non-OECD","China"), col=c(1,4), lty=c(1,1), pch=c(1,2), bty="n", lwd=lwidnum, cex=1.5)
dev.off()
  
  