#######################################################
# Trapped Factors and China's Impact on Global Growth
# Bloom, Romer, Terry, Van Reenen
# File to produce Figure 11, Table 4
# Questions to stephenjamesterry@gmail.com
######################################################


#set compute.underlying to 1 if you want to produce everything from scratch (longer)
#otherwise, set to 0 if you want to read pre-computed values (faster)
compute.underlying = 1

if (compute.underlying==1) {

setwd("./baseline")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./sigma_15")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./sigma_2")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./rho_60")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./rho_40")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./eta_50")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./beta_104")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./beta_101")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./alpha_70")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")

setwd("./alpha_50")
source("fm_transition.R")
source("tf_transition.R")
source("graph_decompose.R")
setwd("..")
}

rm(list=ls())
library(matlab)
options(digits=15)
load(file="./baseline/graphout_tf.rda")
graphout.tf.baseline=graphout.tf
load(file="./baseline/welfare.rda")
welfare.vec.baseline = welfare.vec

load(file="./eta_50/graphout_tf.rda")
graphout.tf.eta50=graphout.tf
load(file="./eta_50/welfare.rda")
welfare.vec.eta50 = welfare.vec


load(file="./rho_60/graphout_tf.rda")
graphout.tf.rho60=graphout.tf
load(file="./rho_60/welfare.rda")
welfare.vec.rho60 = welfare.vec


load(file="./beta_104/graphout_tf.rda")
graphout.tf.beta104=graphout.tf
load(file="./beta_104/welfare.rda")
welfare.vec.beta104 = welfare.vec

load(file="./alpha_50/graphout_tf.rda")
graphout.tf.alpha50=graphout.tf
load(file="./alpha_50/welfare.rda")
welfare.vec.alpha50 = welfare.vec


load(file="./sigma_2/graphout_tf.rda")
graphout.tf.sigma2=graphout.tf
load(file="./sigma_2/welfare.rda")
welfare.vec.sigma2 = welfare.vec

load(file="./sigma_15/graphout_tf.rda")
graphout.tf.sigma15=graphout.tf
load(file="./sigma_15/welfare.rda")
welfare.vec.sigma15 = welfare.vec

load(file="./rho_40/graphout_tf.rda")
graphout.tf.rho40=graphout.tf
load(file="./rho_40/welfare.rda")
welfare.vec.rho40 = welfare.vec

load(file="./alpha_70/graphout_tf.rda")
graphout.tf.alpha70=graphout.tf
load(file="./alpha_70/welfare.rda")
welfare.vec.alpha70 = welfare.vec

load(file="./beta_101/graphout_tf.rda")
graphout.tf.beta101=graphout.tf
load(file="./beta_101/welfare.rda")
welfare.vec.beta101 = welfare.vec


T = dim(graphout.tf)[1]-1
assign('numyrs',10)


numperbefore = 2
numperafter = 5

axis = -numperbefore:numperafter


lwidnum=2


irate.lim = c(4.0,4.8)
growth.lim = c(1.9,3.5)
xrate.lim= c(0.4,0.75)
mu.lim=c(60,120)
fsize=10

pdf(file="Figure_11.pdf")
par(ps = fsize, cex = 1, cex.main = 1.5,cex.lab=1.5,cex.axis=1.5)



g.phi = graphout.tf.beta104$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.beta104$g[1:(numperafter+1)])^(1/numyrs)-1))
plot(axis,plot.vec,type="l",main="Variety Growth",xlab="Period",ylab="Annual %",lwd=lwidnum,ylim=growth.lim,col=2,lty=2)
points(axis,plot.vec,pch=2,col=2)

g.phi = graphout.tf.beta101$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.beta101$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=3,lty=1)
points(axis,plot.vec,pch=3,col=3)

g.phi = graphout.tf.eta50$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.eta50$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=4,lty=2)
points(axis,plot.vec,pch=4,col=4)

g.phi = graphout.tf.sigma2$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.sigma2$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=5,lty=1)
points(axis,plot.vec,pch=5,col=5)


g.phi = graphout.tf.sigma15$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.sigma15$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=6,lty=2)
points(axis,plot.vec,pch=6,col=6)

g.phi = graphout.tf.rho60$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.rho60$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=7,lty=1)
points(axis,plot.vec,pch=7,col=7)

g.phi = graphout.tf.rho40$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.rho40$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=8,lty=2)
points(axis,plot.vec,pch=8,col=8)

g.phi = graphout.tf.alpha50$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.alpha50$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=9,lty=1)
points(axis,plot.vec,pch=9,col=9)

g.phi = graphout.tf.alpha70$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.alpha70$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,lwd=lwidnum,ylim=growth.lim,col=10,lty=2)
points(axis,plot.vec,pch=10,col=10)


g.phi = graphout.tf.baseline$g[1]
plot.vec = c(100*((1+g.phi)^(1/numyrs)-1)*ones(numperbefore,1),
             100*((1+graphout.tf.baseline$g[1:(numperafter+1)])^(1/numyrs)-1))
lines(axis,plot.vec,col=1,lwd=lwidnum,ylim=growth.lim,lty=1)
points(axis,plot.vec,pch=1)

legend.vec=c(expression(paste(beta," = 1/1.04")),
             expression(paste(beta," = 1/1.01")),
             expression(paste(eta," = 0.5")),
             expression(paste(sigma," = 2.0")),
             expression(paste(sigma," = 1.5")),
             expression(paste(rho," = 0.6")),
             expression(paste(rho," = 0.4")),
             expression(paste(alpha," = 0.5")),
             expression(paste(alpha," = 0.7")),
             "Baseline")

legend("topleft",legend.vec,cex=1.5,lty=c(2,1,2,1,2,1,2,1,2,1),col=c(2,3,4,5,6,7,8,9,10,1),
       pch=c(2,3,4,5,6,7,8,9,10,1),bty="n",lwd=lwidnum)


dev.off()



WELFARE.VEC.COMBINED = rbind(welfare.vec.beta104,
                             welfare.vec.beta101,
                             welfare.vec.eta50,
                             welfare.vec.sigma2,
                             welfare.vec.sigma15,
                             welfare.vec.rho60,
                             welfare.vec.rho40,
                             welfare.vec.alpha50,
                             welfare.vec.alpha70,
                             welfare.vec.baseline)

sink(file="Table_4.txt")
cat('###### Table 4 Welfare Robustness','\n')
print(round(WELFARE.VEC.COMBINED,digits=1))
sink(file=NULL)



